---
title: MediaStream()
slug: Web/API/MediaStream/MediaStream
tags:
  - API
  - Audio
  - Constructor
  - Media
  - Media Capture and Streams
  - Media Capture and Streams API
  - MediaStream
  - Reference
  - Streams
  - Tracks
  - Video
  - WebRTC
  - streaming
---
<div>{{APIRef("Media Capture and Streams")}}</div>

<p><span class="seoSummary">The <strong><code>MediaStream()</code></strong> constructor returns a newly-created {{domxref("MediaStream")}}, which serves as a collection of media tracks, each represented by a {{domxref("MediaStreamTrack")}} object.</span> If any parameters are given, the specified tracks are added to the new stream. Otherwise, the stream has no tracks.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox"><var>newStream</var> = new MediaStream();
<var>newStream</var> = new MediaStream(<var>stream</var>);
<var>newStream</var> = new MediaStream(<var>tracks[]</var>);
</pre>

<h3 id="Parameters">Parameters</h3>

<dl>
 <dt><code><var>stream</var></code></dt>
 <dd>A different {{domxref("MediaStream")}} object whose tracks are added to the newly-created stream automatically. The tracks are not removed from the original stream, so they're shared by the two streams.</dd>
 <dt><code><var>tracks</var></code></dt>
 <dd>An {{jsxref("Array")}} of {{domxref("MediaStreamTrack")}} objects, one for each track to add to the stream.</dd>
</dl>

<h3 id="Return_value">Return value</h3>

<p>A newly-created {{domxref("MediaStream")}} object, either empty, or containing the tracks provided, if any.</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName('Media Capture', '#mediastream', 'MediaStream')}}</td>
   <td>{{Spec2('Media Capture')}}</td>
   <td> </td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.MediaStream.MediaStream")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li>{{domxref("MediaStream")}}</li>
</ul>
